
// Drehzahlmesser_mit_28BYJ48_11v25-01-2019
// ...... Bibliotheken ........

#include <Stepper.h> // Include the header file

// ---- Variablen für den Schrittmotor

int RPM_stepp = 0; // Umrechnung Drehhzahl in Schrittte für den Schrittmotor 
const int scala_max = 8000; // maximal angezeigte Drehzahl laut Scala,  Die Skala geht bis 8000 U/
const int max_stepps = 1252; // Anzahl der max_stepps von 0 bis Maximalanzeige z.B. eine volle Umdrehung des 28BYJ48 sind 2048  = 5,68 Schritte pro Grad die Scala geht über 220 Grad " 5,688 Grad pro Schritt) * 220 Grad = 1252 
unsigned long micro_Stepper_alt = 0; // merken wenn die Subroutine den Schrittmotor angesteuert hat, zweck auch wenn sich die Drehzahl nicht ändert soll der Schrittmotor nachgeführt werden sollt er die richtige Position noch nicht erreicht haben
unsigned long jetzt = 0; // aktueller Zeitpunkt dient dazu die zeit zwischen der letzten Ansteuerung Schrittmotor und dem Jetzt zu bestimmen 
unsigned long delta_Ansteuerung = 0;   // die Differenz zwischen der letzten Ansteuerung des Schrittmotor und jetzt

int Pos_Stepper = 0; // wo steht der Schrittmotor gerade diese Variabel wird zum zählen verwendet.
int delta_stepps = 0; // wie weit ist er von der Sollposition entfernt ?
unsigned int schrittweite_stepps = 1; // 1 hat sich als der beste Kompromiss erwiesen !!! der Schrittmotor wird in einzelschritten nachgeführt !!

#define STEPS 32 // change this to the number of steps on your motor
Stepper stepper(STEPS, 8, 10, 9, 11); // create an instance of the stepper class using the steps and pins
//                 IN  1   3  2   4   input Pin am Driver Board dreht bei Erhöhung der Drehzahl nach links
//                 IN  4   2  3   1   input Pin am Driver Board dreht bei Erhöhung der Drehzahl nach rechts 

// --- Variabel Deffinition ---------------
volatile unsigned long micro = 0;      // der aktuelle Wert readmicros
volatile unsigned long micro_alt = 0;  // der Wert der vorangegangenen readmicros
volatile unsigned long diff = 0;   // die Differenz = Dauer einer Umdrehung
volatile unsigned long diff1 = 0;
volatile unsigned long diff2 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long diff3 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long diff4 = 0;   // für die Mittelwert Glättung verschieben der Werte 
volatile unsigned long Drehzahl = 0; // die errechnete Drehzahl 
volatile long Drehzahl_diff= 0 ; // der alte Wert die errechnete Drehzahl
volatile unsigned long Drehzahl_angezeigt = 0; // die errechnete Drehzahl 
volatile int delta; // Zum einstellen der Sprungwerte zwischen den angezeigten Drehzahlen
volatile boolean aktiv = 0; // soll die Drehzahl ausgegeben werden ?
long timeout; // die Zeitspanne zwischen zwei interrupts

int Zeiger = 0;  // ist der Zeiger in der Position 0 ?
boolean genullt = 0;  // ist der Zeiger zurückgeführt ? 0 = noch nicht 


void setup() {
Serial.begin(57600);

// ---- Variablen für den Schrittmotor
stepper.setSpeed(1200);


pinMode(2, INPUT); // Eingangspin auf Eingang stellen - Signaleingang Drehzahmessung
digitalWrite(2, HIGH); // und Pullup-Widerstand einschalten heist gemessen wird wenn der Eingang auf 0 gezogen wird.
attachInterrupt(0, readmicros, FALLING);  // Interrupt 0 auf Routine readmicros setzen

pinMode(LED_BUILTIN, OUTPUT); // Warnung Bei drehzahlen über den maximalen Scalenwert

// Schrittmotor initialisieren
pinMode(3, INPUT); // Eingangspin auf Eingang stellen erkennen der Nadelposition = Anfang = Position 0
digitalWrite(3, HIGH); // und Pullup-Widerstand einschalten
Zeiger = digitalRead(3); // Zustand einlesen um einen definierten Ausgangszustand herzustellen 
if ( Zeiger == HIGH ) {genullt = 1; }; // wenn der Zeiger schon in der null Position ist, braucht man nicht's mehr tun.
if ( genullt == 0 ) { nullen(); }  // ist der Zeiger schon in der null Position ? wenn ned ab in die Subroutiene  


}

//..............................................................................................
void loop(){

    

Drehzahl_diff = Drehzahl_angezeigt - Drehzahl;
Drehzahl_diff = abs(Drehzahl_diff); // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 
// nicht jede Wert soll ein Aktion auslösen! ----------------------------------------
if (Drehzahl <= 1500) { delta = 10;} 
if (Drehzahl > 1500 && Drehzahl <= 2500) {delta = 50;}
if (Drehzahl > 2500 ) {delta = 100;} 



// nur wenn Delta Alt Neue Drehzahl einen bestimmten wert überschreitet soll er angezeigt werden.
if (aktiv == 1 && Drehzahl_diff >= delta) { Drehzahl_angezeigt = Drehzahl; Schrittmotor(); }


// ---------- ist die Anzeige aktuell ? -----------------------------
jetzt = micros(); // Microsekundenzähler auslesen
delta_Ansteuerung = jetzt - micro_Stepper_alt; // Die Zeit zwischen der letzten Ansteuerung des Schrittmotor und jetzt
if (aktiv == 1 && delta_Ansteuerung > 10000L && delta_stepps > 0 ) Schrittmotor(); // einstellen der Empfindlichkeit beim Nachfahren der Anzeige


// Stillstand erkennen
timeout = micros() - micro_alt;
if (timeout > 2000000L)  aktiv = 0;   // Inaktivität unter 10 U/Min = 2 Sec
if (aktiv == 0) nullen();    // Zeiger Zurückführen

  
}

//------------------------------------------------------------------------------------------
void readmicros() { // Die Dauer zwischen zwei Impulsen auslesen
// detachInterrupt(0); // Interrupt 0 ausschalten
if ( aktiv == 0 || micro_alt == 0) micro_alt = micros();
aktiv = 1;
micro = micros(); // Microsekundenzähler auslesen
diff = micro - micro_alt; // Differenz zum letzten Durchlauf berechnen
if (diff > 4000L) { // Drehzahen bzw. Impulsfolgen größer 15000U/Min werden als Fehler erachtet und ignoriert   
                   micro_alt = micro;  // Letzten Wert merken
   if (Drehzahl < 2500) { // genauere Mittelwertbildung 
                            diff4 = diff3;
                            diff3 = diff2;
                            diff2 = diff1;
                            diff1 = diff;
                            // diff = (diff1 + diff2 + diff3 + diff4)/4;  // Mittelwert bilden 
                            if (diff4 > 0 ) {diff = (diff1 + diff2 + diff3 + diff4)/4; Drehzahl = 60000000L / diff; } // else {Drehzahl = 60000000L / diff1;} // Drehzahl ausrechnen und (60000000 durch die Anzahl der Magneten teilen, ist in dem Fall = 1 
                        }                                                                                     // bei den ersten Impulsen werden erst die Werte diff2 - 4 befüllt deshalb die Berechnung mit diff1
   
                     else {  //  wenn die Drehzahl höher wird, wird die Berechnung beschleunigt
                              diff2 = diff1;
                              diff1 = diff;
                              diff = (diff1 + diff2 )/2;  // Mittelwert bilden 
                              Drehzahl = 60000000L / diff;
                              if (Drehzahl > scala_max) {Drehzahl = scala_max; digitalWrite(LED_BUILTIN, HIGH);} else {digitalWrite(LED_BUILTIN, LOW);} // ist die errechnete Drehzahl höher als scala_max U/Min dann den Wert auf scala_max setzen und die LED einschalten
                         }
                   }
// attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 auf Routine readmicros setzen
 }




//-----------------------------------------------------------------------------------------

void clockwise() {
//  detachInterrupt(0); // Interrupt 0 ausschalten

if ((Pos_Stepper + schrittweite_stepps) > max_stepps) { schrittweite_stepps = (max_stepps - Pos_Stepper); }
                                                      
stepper.step(schrittweite_stepps);
Pos_Stepper = Pos_Stepper + schrittweite_stepps ;

delta_stepps = RPM_stepp - Pos_Stepper;    // wo stehe ich und wo will ich hin ?
delta_stepps = abs(delta_stepps);          // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 
// Serial.print("delta="); Serial.print(delta_stepps);   
// Serial.print("  RPM= ");Serial.println(Drehzahl_angezeigt);

micro_Stepper_alt = micros(); // Zeitpunkt merken an dem der Schrittmotor stehen bleibt
// attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 auf Routine readmicros setzen
}

//-----------------------------------------------------------------------------------------
void anticlockwise() {
// detachInterrupt(0); // Interrupt 0 ausschalten
if (Pos_Stepper < schrittweite_stepps) { schrittweite_stepps = Pos_Stepper; }

stepper.step(-schrittweite_stepps);
Pos_Stepper = Pos_Stepper - schrittweite_stepps;

delta_stepps = RPM_stepp - Pos_Stepper;    // wo stehe ich und wo will ich hin ?
delta_stepps = abs(delta_stepps);          // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 
// Serial.print("delta="); Serial.print(delta_stepps);   
// Serial.print("  RPM= ");Serial.println(Drehzahl_angezeigt);

micro_Stepper_alt = micros();  // Zeitpunkt merken an dem der Schrittmotor stehen bleibt
// attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 auf Routine readmicros setzen
}

//-----------------------Ansteuerung Schrittmotor-------------------------------------------
void Schrittmotor() { 
                                            
                      // RPM_stepp = map(Drehzahl_angezeigt, 0, scala_max, 0, max_stepps); // Ermitteln der Position in Schritten;  Mappen Drehzahl auf Schritte des Schrittmotor
                      RPM_stepp = map(Drehzahl, 0, scala_max, 0, max_stepps);
                      
                      //Vergleich der aktuellen mit der geforderten Position + entscheiden in welche Richtung soll der Motor Drehen
                      delta_stepps = RPM_stepp - Pos_Stepper;    // wo stehe ich und wo will ich hin ?
                      delta_stepps = abs(delta_stepps);          // die Bildung des abs Wert getrennt von der Berechnung, so gefordert in der Arduino IDE 
                      
                      // bei Annäherung an das Ziel wird die Schrittweite geringer !!!! der Wert 1 hat sich als Ziehlführend erwiesen !!!!!!----------------------------------------
                      // schrittweite_stepps = delta_stepps; // läuft immer der Drehzahl nach
                      /*  
                      if (delta_stepps < 10)schrittweite_stepps = delta_stepps;
                      if (delta_stepps >= 10 && delta_stepps < 50) schrittweite_stepps = 10;
                      if (delta_stepps >= 50 && delta_stepps < 100) schrittweite_stepps = 50;
                      if (delta_stepps > 100) schrittweite_stepps = 100;
                      */
                      if (RPM_stepp > Pos_Stepper) clockwise();     // ansteuern des Schrittmotor
                      if (RPM_stepp < Pos_Stepper) anticlockwise(); // ansteuern des Schrittmotor
                                         
                      // Serial.print("Pos="); Serial.print(Pos_Stepper);   Serial.print("  RPM= ");Serial.println(Drehzahl_angezeigt);
                    } 

//------------------------------------------------------------------------------------------
void nullen() { // Schrittmotor auf die Startposition bewegen. Scalenwert 0
detachInterrupt(0); // Interrupt 0 ausschalten damit in Ruhe initialisiert werden kann

Serial.println("NULLEN");

for (int c = 0; c < max_stepps; c++)  { Zeiger = digitalRead(3); 
                             if ( Zeiger == LOW ) {stepper.step (-1);}
                             }
                                     
genullt = 1; // Erfolgreich initialisiert
Pos_Stepper = 0; // Der Zeiger seht auf Position 0
diff4 = 0; diff3 = 0; diff2 = 0; diff1 = 0; // initialisieren ;-) die Drehzahl erst nach dem 4ten Impuls berechnet 
Drehzahl = 0; // damit bei Aktiv = 1 nicht der alte Wert angezeigt wird befor er bei der Berechnung mit dem neuen Wert überschrieben wird
Drehzahl_angezeigt = 0; // damit bei Aktiv = 1 nicht der alte Wert angezeigt wird befor er bei der Berechnung mit dem neuen Wert überschrieben wird
attachInterrupt(0, readmicros, FALLING);   // Interrupt 0 wieder einschalten jetzt kann es losgehen
  
  }
  
  //--------------------------------------------------------------------------------------------------------
